// led_button.c

#include <bcm2835.h>

// LEDs on P11=GPIO17, P13=GPIO27, P15=GPIO22
uint8_t LED[3] = { RPI_V2_GPIO_P1_11, RPI_V2_GPIO_P1_13, RPI_V2_GPIO_P1_15 };
uint8_t BUTTON[2] = { RPI_V2_GPIO_P1_16, RPI_V2_GPIO_P1_18 };
uint8_t ON = 1;
uint16_t DELAY = 200;

int main(int argc, char **argv)
{

    if (!bcm2835_init())
	return 1;

    // Set the pin to be an output
    bcm2835_gpio_fsel(LED[0], BCM2835_GPIO_FSEL_OUTP);
    bcm2835_gpio_fsel(LED[1], BCM2835_GPIO_FSEL_OUTP);
    bcm2835_gpio_fsel(LED[2], BCM2835_GPIO_FSEL_OUTP);

    // Set inputs
    bcm2835_gpio_fsel(BUTTON[0], BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(BUTTON[1], BCM2835_GPIO_FSEL_INPT);

    // Blink
    while (1)
    {
        for(int idx=0; idx<3; idx++)
        {
    	  // Turn it on/off
	  bcm2835_gpio_write(LED[idx], ON);
	  // wait a bit
	  bcm2835_delay(DELAY);
        }
        // switch on/off	
        ON = !ON;

        if (bcm2835_gpio_lev(BUTTON[0])) { DELAY -= 10; }
        if (bcm2835_gpio_lev(BUTTON[1])) { DELAY += 10; }
        if (bcm2835_gpio_lev(BUTTON[0]) && bcm2835_gpio_lev(BUTTON[1])) 
        {
          // exiting
          for(int idx=0; idx<3; idx++)
          {
            bcm2835_gpio_write(LED[idx], LOW);
          }
          bcm2835_close();
          return 0;
        }
    }
}

