#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <bcm2835.h>


int read_hyt221() {

        if (!bcm2835_init())
          return 1;

        bcm2835_i2c_begin();

        // Device 0x28
        bcm2835_i2c_setSlaveAddress(0x28);
        bcm2835_i2c_setClockDivider(BCM2835_I2C_CLOCK_DIVIDER_2500);

	char buf[4];
        
	char cmd_mr[] = {0x00};	// Measurement Request

	//i2c_write(0x28, 0x00, &cmd_mr, 1);
	//i2c_read(0x28, 0x00, &cmd_mr, 0);
        bcm2835_i2c_write(cmd_mr, 1);
        usleep(4500); // just wait for conversion
	//i2c_read(0x28, 0x00, buf, 4);
        bcm2835_i2c_read(buf, 4);

	printf("%d %d %d %d\n", buf[0], buf[1], buf[2], buf[3]);

	long hum = (long)buf[0] << 8 | buf[1]; 
	long temp = (long)buf[2] << 6 | buf[4] >> 2;
	float t;
	t = (float)temp * 165 / powf(2,14) -40;	

	hum = hum & 0x3fff;
	float h;
	h = (float)hum * 100 / powf(2,14);
//	hum = 100 / ((2^14)*hum);
//	temp = 165 / 2^14*temp-40;

	printf("HYT 221 Temperatur: %0.1fC \n", t);
	printf("           Feuchte: %0.1f%%\n", h);
//	printf("Temperature: %0.1fC\n", temperature_deg_c);

        bcm2835_i2c_end();
        bcm2835_close();

	return 0;
}
