// lm75.c

#include <bcm2835.h>
#include <stdio.h>

static char data[3];
float t;

int main(int argc, char **argv)
{


  if (!bcm2835_init())
    return 1;

  bcm2835_i2c_begin();

  // set i2c slave
  bcm2835_i2c_setSlaveAddress(0x48);
  bcm2835_i2c_setClockDivider(BCM2835_I2C_CLOCK_DIVIDER_626);

  while (1)
  {
    // read data
    bcm2835_i2c_read(data, 2);
    //printf("Raw read: %02x %02x\n", data[0], data[1]);

    t = (float)(data[0] << 1 | data[1] >> 7)/2;
    printf("Temperatur: %.1f °C\n", t);
    delay(500);
  }

  bcm2835_i2c_end();
  bcm2835_close();

  return 0;
}
